
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef MOUSE3D_PRINTXML_H
#define MOUSE3D_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/genManipPrintXML.h"

#include "server/genBasicPrintXML.h"


#include "mouse3dPosterLib.h"

/* Prototypes */
extern void printXML_struct_MOUSE3D_MEASURES_POSTER_STR ( FILE *out, char *name,
     struct MOUSE3D_MEASURES_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_mouse3d_ids ( FILE *out, char *name,
     struct mouse3d_ids *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_mouse3d_thresholds ( FILE *out, char *name,
     struct mouse3d_thresholds *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_mouse3d_gains ( FILE *out, char *name,
     struct mouse3d_gains *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_mouse3d_bindings ( FILE *out, char *name,
     struct mouse3d_bindings *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_mouse3d_path ( FILE *out, char *name,
     struct mouse3d_path *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_mouse3d_path ( FILE *out, char *name,
     mouse3d_path *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_mouse3d_bindings ( FILE *out, char *name,
     mouse3d_bindings *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_mouse3d_gains ( FILE *out, char *name,
     mouse3d_gains *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_mouse3d_thresholds ( FILE *out, char *name,
     mouse3d_thresholds *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_mouse3d_ids ( FILE *out, char *name,
     mouse3d_ids *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_MOUSE3D_MEASURES_POSTER_STR ( FILE *out, char *name,
     MOUSE3D_MEASURES_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* MOUSE3D_PRINT_XML_H */

