
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef mouse3d_TCLSERV_CLIENT_MSG_LIB_H
#define mouse3d_TCLSERV_CLIENT_MSG_LIB_H

#include <server/mouse3dType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int mouse3dTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int mouse3dTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int mouse3dTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 mouse3d_path *(in_device) 
		);

int mouse3dTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int mouse3dTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				mouse3d_path *(in_device) ,
				
				int *bilan);

int mouse3dTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					mouse3d_path *(in_device) ,
					
					int *bilan);




int mouse3dTclservClientExportRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int mouse3dTclservClientExportReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int mouse3dTclservClientExportRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int mouse3dTclservClientExportRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int mouse3dTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int mouse3dTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int mouse3dTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int mouse3dTclservClientBindingsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 mouse3d_bindings *(in_bindings)
		);

int mouse3dTclservClientBindingsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int mouse3dTclservClientBindingsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 mouse3d_bindings *(in_bindings) ,
				 
				 int *bilan);




int mouse3dTclservClientGainsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 mouse3d_gains *(in_gains)
		);

int mouse3dTclservClientGainsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int mouse3dTclservClientGainsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 mouse3d_gains *(in_gains) ,
				 
				 int *bilan);




int mouse3dTclservClientThresholdsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 mouse3d_thresholds *(in_thresholds)
		);

int mouse3dTclservClientThresholdsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int mouse3dTclservClientThresholdsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 mouse3d_thresholds *(in_thresholds) ,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* mouse3dTCLSERV_CLIENT_MSG_LIB_H */

