
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] mouse3dInstall] >= 0 } {
    interp expose {} mouse3dInstall
}

proc ::mouse3dInstall { name } {
    foreach rqst { "Init" "Export" "Stop" "Bindings" "Gains" "Thresholds" "MeasuresmeasuresPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} mouse3d$rqst $name
    }
}

interp hide {} mouse3dInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dInit] >= 0 } {
    interp expose {} mouse3dInit
}
if { [lsearch [interp hidden] mouse3dInitFormatOutput] >= 0 } {
    interp expose {} mouse3dInitFormatOutput
}

proc ::mouse3dInit { name args } {
    set format {}
    lappend format [list string "Device path (empty for autodetect)" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Initialize the 3d mouse" \
	"mouse3d_path\n| char path\[1024\]\n" \
	1 \
	$format \
	$args ]
}


proc ::mouse3dInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dInit
interp hide {} mouse3dInitFormatOutput





# Export ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dExport] >= 0 } {
    interp expose {} mouse3dExport
}
if { [lsearch [interp hidden] mouse3dExportFormatOutput] >= 0 } {
    interp expose {} mouse3dExportFormatOutput
}

proc ::mouse3dExport { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Export" \
	"Export 3d mouse data in the poster" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::mouse3dExportFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dExport
interp hide {} mouse3dExportFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dStop] >= 0 } {
    interp expose {} mouse3dStop
}
if { [lsearch [interp hidden] mouse3dStopFormatOutput] >= 0 } {
    interp expose {} mouse3dStopFormatOutput
}

proc ::mouse3dStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop exporting 3d mouse data in the poster" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::mouse3dStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dStop
interp hide {} mouse3dStopFormatOutput





# Bindings ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dBindings] >= 0 } {
    interp expose {} mouse3dBindings
}
if { [lsearch [interp hidden] mouse3dBindingsFormatOutput] >= 0 } {
    interp expose {} mouse3dBindingsFormatOutput
}

proc ::mouse3dBindings { name args } {
    set format {}
    lappend format [list int "X axis" 0 ]
    lappend format [list int "Y axis" 1 ]
    lappend format [list int "Z axis" 2 ]
    lappend format [list int "RX axis" 3 ]
    lappend format [list int "RY axis" 4 ]
    lappend format [list int "RZ axis" 5 ]
    lappend format [list int "Button 0" 256 ]
    lappend format [list int "Button 1" 257 ]

    return [ ::cs::rqstSend "${name}" "Bindings" \
	"Map axes and buttons" \
	"mouse3d_bindings\n| unsigned short int x\n| unsigned short int y\n| unsigned short int z\n| unsigned short int rx\n| unsigned short int ry\n| unsigned short int rz\n| unsigned short int b0\n| unsigned short int b1\n" \
	8 \
	$format \
	$args ]
}


proc ::mouse3dBindingsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dBindings
interp hide {} mouse3dBindingsFormatOutput





# Gains ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dGains] >= 0 } {
    interp expose {} mouse3dGains
}
if { [lsearch [interp hidden] mouse3dGainsFormatOutput] >= 0 } {
    interp expose {} mouse3dGainsFormatOutput
}

proc ::mouse3dGains { name args } {
    set format {}
    lappend format [list double "X axis gain" 1.000000 ]
    lappend format [list double "Y axis gain" 1.000000 ]
    lappend format [list double "Z axis gain" 1.000000 ]
    lappend format [list double "RX axis gain" 1.000000 ]
    lappend format [list double "RY axis gain" 1.000000 ]
    lappend format [list double "RZ axis gain" 1.000000 ]

    return [ ::cs::rqstSend "${name}" "Gains" \
	"Gains on axes" \
	"mouse3d_gains\n| double x\n| double y\n| double z\n| double rx\n| double ry\n| double rz\n" \
	6 \
	$format \
	$args ]
}


proc ::mouse3dGainsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dGains
interp hide {} mouse3dGainsFormatOutput





# Thresholds ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dThresholds] >= 0 } {
    interp expose {} mouse3dThresholds
}
if { [lsearch [interp hidden] mouse3dThresholdsFormatOutput] >= 0 } {
    interp expose {} mouse3dThresholdsFormatOutput
}

proc ::mouse3dThresholds { name args } {
    set format {}
    lappend format [list double "X axis gain" 0.000000 ]
    lappend format [list double "Y axis gain" 0.000000 ]
    lappend format [list double "Z axis gain" 0.000000 ]
    lappend format [list double "RX axis gain" 0.000000 ]
    lappend format [list double "RY axis gain" 0.000000 ]
    lappend format [list double "RZ axis gain" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "Thresholds" \
	"Thresholds on axes motion (after gain)" \
	"mouse3d_thresholds\n| double x\n| double y\n| double z\n| double rx\n| double ry\n| double rz\n" \
	6 \
	$format \
	$args ]
}


proc ::mouse3dThresholdsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dThresholds
interp hide {} mouse3dThresholdsFormatOutput





# Measuresmeasures ----------------------------------------------------------

if { [lsearch [interp hidden] mouse3dMeasuresmeasuresPosterRead] >= 0 } {
    interp expose {} mouse3dMeasuresmeasuresPosterRead
}
if { [lsearch [interp hidden] mouse3dMeasuresmeasuresPosterFormatOutput] >= 0 } {
    interp expose {} mouse3dMeasuresmeasuresPosterFormatOutput
}

proc ::mouse3dMeasuresmeasuresPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Measuresmeasures" \
	"GENMANIP_MOUSE3D_STR\n| double x\n| double y\n| double z\n| double Rx\n| double Ry\n| double Rz\n| int b0\n| int b1\n" \
	$args ]
}


proc ::mouse3dMeasuresmeasuresPosterFormatOutput { list } {
    set format { {} status { } { measures { } x { } y { } z { } Rx { } Ry { } Rz { } b0 { } b1 } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mouse3dMeasuresmeasuresPosterRead
interp hide {} mouse3dMeasuresmeasuresPosterFormatOutput


